package dataLoad;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;

/**
 * Class to read text data.
 * @author 
 *
 */
public class CSVReader {

	List<String>titleLine = new ArrayList<String>();
	Map<Integer,String> otherLines = new HashMap<Integer,String>();
	
	public CSVReader(){
		
	}
	
	/**
	 * Method to parse line.
	 * @param lines
	 */
	public void parseLines(List<String> lines){
		
		Iterator<String> ic  = lines.iterator();
		int i=0;
		while(ic.hasNext()){
			String line = ic.next();
			if(i==0){
				titleLine.add(line);
			}
			else{
				otherLines.put(i, line);
			}
			i++;
		}
	}
	
	/**
	 * Method to open a file.
	 * @param file
	 */
	public void openFiles(File file){
			
			System.out.println(file.getName());
			try {
				List<String> lines=FileUtils.readLines(file);
				parseLines(lines);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}
	
	/**
	 * Method to read file.
	 * @param file the file.
	 */
	public void readData(String file){
		File directory = new File(file);
		openFiles(directory);
	}

	public List<String> getTitleLine() {
		return titleLine;
	}

	public void setTitleLine(List<String> titleLine) {
		this.titleLine = titleLine;
	}

	public Map<Integer, String> getOtherLines() {
		return otherLines;
	}

	public void setOtherLines(Map<Integer, String> otherLines) {
		this.otherLines = otherLines;
	}
	
	
}
