package entities;

import repast.simphony.space.graph.RepastEdge;

/**
 * The edge of a settlement network.
 * 
 * @author
 *
 * @param <Settlement>
 */
@SuppressWarnings("hiding")
public class SettlementEdge extends RepastEdge {
	
	/**How many times an agent goes to a given settlement from another settlement*/
	public double used=0d;  //times walked/boated/or just moved through
	
	
	/**
	 * The settlement edge.
	 * @param first the source settlement
	 * @param second the target settlement
	 */
	public SettlementEdge(Settlement first, Settlement second){
		super(first,second,true);
	}

	
	
    public double getUsed ( ) {
    
    	return used;
    }

	
    public void setUsed ( double used ) {
    
    	this.used = used;
    }
	
}