/**
 * 
 */
package output;

/**
 * Output interface for GIS data
 * @author 
 * @param <T>
 *
 */
public interface GISOutput<T> {

	/**
	 * Method to calculate the output for displaying in a gis tool
	 */
	public void initiateCalculation(T O);
	
	/**
	 * Get result deailing with volume calculations
	 * @return a volume quantity
	 */
	public double getVolume();
	
	/**
	 * Method for outputting data into a shapefile
	 * @param category the category of agent
	 */
	public void writeShapefile(String category)throws Exception;
	
	/**
	 * Method for outputting data into a text file
	 * @param category the category of agent
	 */
	public void writeOutput(String category);

}
