package output;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;

import entities.Settlement;
import repast.simphony.engine.environment.RunEnvironment;


/**
 * Class to output csv data for settlements
 * 
 * @author 
 *
 */
public class Outputter {

	public static int runNumber=0;
	public static boolean started=false;
	
	static String seperator=",";
	static String fileName="."+File.separator+"output"+File.separator+"ModelOutput";
//	static String fieldName=".."+File.separator+"Cities"+File.separator+"output"+File.separator+"FieldOutput";
//	static String titleLine="Tick,X,Y,Size,Flow,Name";
	static String fieldLine="Tick,X,Y,Alpha,Beta,Name,Flow,Size,Population";
	static double alpha,beta;
	static double timeStamp=0;
	
	/**
	 * This method sets up the output to be done.
	 * @param c
	 * @return
	 */
	public static List doOutput(Settlement c){
		List<String>output = new ArrayList<String>();
		String tick=Double.toString(RunEnvironment.getInstance().getCurrentSchedule().
				getTickCount());
		if(Double.parseDouble(tick)==0.0)
			timeStamp=System.currentTimeMillis();
		
		String x=Double.toString(c.getX());
		String y=Double.toString(c.getY());
		
		double alpha=c.alpha;
		double beta=c.beta;
		String name=Integer.toString(c.idN);
		double c1=c.getFlow();
		
		Outputter.alpha=alpha;
		Outputter.beta=beta;
		
		String line=tick+seperator+x+seperator+y+seperator+alpha+seperator+beta+seperator+
				name+seperator+c1+seperator+c.realSize+seperator+c.population;
		output.add(line);
		
		return output;
	}
	
	/**
	 * This is the text file data output method.
	 * @param lines
	 */
	public static void writeData(List<String> lines){
		List<String> oldLines=null;
		double tick=RunEnvironment.getInstance().getCurrentSchedule().getTickCount();
		
		
		try {
			lines.add(0, fieldLine);
			FileUtils.writeLines(new File(fileName+runNumber+"_"+Outputter.alpha+"_"+Outputter.beta+"_"+".csv"), lines);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
